;;########################################################################
;; anovavis.lsp
;; Copyright (c) 1993-96 by Forrest W. Young
;; anovavis.lsp and anovavs2.lsp contain the code for anova visualization.
;;########################################################################

(require "vista")

(defmeth anova-model-object-proto :visualize ()
  (if (not (eq current-object self)) (setcm self))
  (let* ((my-data (send self :data-object))
         (nway (send self :nway-model))
         (bp nil) (dnl nil) (lp nil) (rp nil)
         (bp-y-range nil)
         (bp-y-axis nil)
         (nways (send my-data :nways))
         (ways (send my-data :ways))
         (sources (send (send *current-model* :nway-model) :source-names))
         (design (combine "Overall" sources))
         (data (combine (send self :data)))
         (data-mean (mean data))
         (grouped-data (send my-data :grouped-data 0))
         (labels (send my-data :level-names))
         )
    (setf bp (boxplot data 
                      :location location11
                      :show nil
                      :size (+ 
                           #+macintosh'(17 0)
                           #+msdos    '( 8 0) 
                           (* '(2 1) graph-size))
                      :boxes nil :diamonds t :mean-line t
                      :variable-labels '("Overall")))
    (send bp :y-axis t t (third (send bp :y-axis)))
    (send bp :variable-label 1 (first (send my-data :variables)))
    (send bp :showing-labels t)
    (send bp :linked t)
    (send bp :show-window)
    (defmeth bp :close ()
      (send bp  :remove)
      (send pp  :remove)
      (send dnl :remove)
      (send lp  :remove)
      (send rp  :remove)) 
    (setf bp-y-range (send bp :range 1))
    (setf bp-y-axis  (send bp :y-axis))


    (setf dnl (name-list design
                         :show nil
                         :location location13
                         :title "Sources"))
    (send dnl :menu nil)
    (send dnl :show-window)
    (send dnl :size (- (first namelist-size) msdos-fiddle)
          (- (second namelist-size) msdos-fiddle))
    (defmeth dnl :close ()
      (send bp :close))

    (defmeth dnl :do-select-click (&rest args)
      (apply #'call-next-method args)
      (when (send self :selection)
            (let* ((sel (first (send self :selection)))
                   (num (send self :num-points))
                   (ways (send my-data :ways))
                   (nways (send my-data :nways)))
              (cond
                ((= sel 0) 
                 (send current-model :profile-labels nil)
                 (send bp :new-plot (combine (send my-data :data))
                       :variable-labels '("Overall"))
                 (send pp :clear)
                 (send pp :variable-label 0 "")
                 (send pp :redraw)
                 (send rp :source 0)
                 (send rp :new-plot 0)
                 (send lp :new-plot 0 current-model
                       :y-range bp-y-range :y-axis bp-y-axis
                       :y-mean data-mean))
                ( t
                  (when (<= sel nways)
                        (send current-model :profile-labels 
                              (nth (1- sel) (send my-data :classes))))
                  (send bp :new-plot (send my-data :grouped-data (1- sel))
                        :variable-labels 
                        (nth (1- sel) (send my-data :level-names)))
                  (send rp :source sel)
                  (send rp :new-plot sel)
                  (send lp :new-plot sel current-model
                        :y-range bp-y-range :y-axis bp-y-axis
                        :y-mean data-mean)
                  (send pp :new-plot 
                        (send my-data :grouped-data (1- sel)) sel))))))
    (setf lp (leverage-plot 0 self
                            :variable-labels (list (strcat "Predicted "
                                             (select (send self :variables) 0))
                                             (select (send self :variables) 0))
                            :location location21
                            :size graph-size
                            :y-range (send bp :range 1)
                            :y-axis  (send bp :y-axis)
                            :y-mean data-mean
                            :show nil))
    (send lp :linked t)
    (send lp :showing-labels t)
    (send lp :redraw)
    (send lp :show-window)
    (defmeth lp :close ()
      (send bp :close))

    (setf rp (residual-plot self
                   :location location22 :size graph-size 
                   :show nil))
    (defmeth rp :close ()
      (send bp :close))
    (send rp :linked t)
    (send rp :showing-labels t)
    (send rp :show-window)

    (setf pp (plot-points (1+ (* 2 (iseq (length grouped-data))))
                          (mapcar #'mean grouped-data)
                          :location location23
                          :title "Profile Plot" :show nil
                   ;       :size (list (- (first namelist-size) msdos-fiddle)
                   ;              (- (second namelist-size) msdos-fiddle))
                          ))

    (send pp :size (- (first namelist-size) msdos-fiddle)
          (- (second namelist-size) msdos-fiddle))
    (send pp :range 0 0 (* 2 (length grouped-data)))
    (send pp :range 1 (first (send bp :range 1)) 
          (second (send bp :range 1)))
    (send pp :x-axis t t 0)
    (send pp :clear)
    (send pp :variable-label 0 "")
    (send pp :variable-label 1 (strcat (first (send my-data :variables))
                                      " LS Means"))
    (send pp :y-axis t t (third (send bp :y-axis)))
    (send current-model :profile-labels (first (send my-data :classes)))
    (defmeth pp :close ()
      (send bp :close))
    (send pp :menu nil)
    (send pp :show-window)
                          
    (defmeth pp :new-plot (grouped-data sel)
      (let* ((x (1+ (* 2 (iseq (length grouped-data)))))
             (y (mapcar #'mean grouped-data))
             (y1 nil)
             (nways (send my-data :nways))
             (knt nways)
             (nlevels (send my-data :nclasses))
             (inow nil)
             (ilevels nil)
             (jlevels nil))
        (send current-model :line-labels nil)
        (send current-model :line-xs nil)
        (send current-model :line-ys nil)
        (send pp :start-buffering)
        (send pp :clear)
        (send pp :variable-label 0 "Overall")
        (send pp :range 0 0 0)
        (cond ((<= sel nways)
               (send pp :add-points x y)
               (send current-model :profile-labels 
                     (nth (1- sel) (send my-data :classes)))
               (send pp :add-lines x y)
               (send pp :variable-label 0 (nth (1- sel) (send my-data :ways)))
               (send pp :range 0 0 (* 2 (length grouped-data))))
          (t (dotimes (i (- nways 1))
                      (dolist (j (iseq (1+ i) (- nways 1)))
                              (setf knt (1+ knt))
                              (when (= knt sel)
                                    (send pp :variable-label 0 
                                          (nth j (send my-data :ways)))
                                    (send current-model :profile-labels 
                                          (nth j (send my-data :classes)))
                                    (setf inow i)
                                    (setf ilevels (nth i nlevels))
                                    (setf jlevels (nth j nlevels)))))
             (setf x (1+ (* 2 (iseq jlevels))))
             (dotimes (i ilevels)
                      (setf y1 (select y (iseq (* i jlevels) 
                                            (+ (* i jlevels) (1- jlevels)))))
                      (send pp :add-points x y1)
                      (send pp :add-lines  x y1)
                      (send current-model :line-labels
                            (add-element-to-list 
                             (send current-model :line-labels) 
                             (nth i (nth inow (send my-data :classes)))))
                      (send current-model :line-xs
                            (add-element-to-list (send current-model :line-xs)
                                                 (first (last x))))
                      (send current-model :line-ys
                            (add-element-to-list (send current-model :line-ys)
                                                 (first (last y1))))
                      )
             (send pp :range 0 0 (* 2 (length x)))))
        (send pp :buffer-to-screen)
        ))

    (defmeth pp :redraw ()
      (send self :start-buffering)
      (call-next-method)
      (when (> (send self :num-points) 0) (send self :label-x-axis))
      (send self :buffer-to-screen))
    
    (defmeth pp :label-x-axis ()
      (let* ((labels (send current-model :profile-labels))
             (line-labels (send current-model :line-labels))
             (h (send self :canvas-height))
             (x (send self :point-canvas-coordinate 0 (iseq (length labels))))
             (o (first (send self :content-origin)))) 
        (dotimes (i (length labels))
                 (send self :draw-line (+ o (nth i x)) (- h 45) 
                       (+ o (nth i x)) (- h 40))
                 (send self :draw-text (select labels i) 
                       (+ o (nth i x)) (- h 25) 1 0))
        (when (send current-model :line-labels)
              (dotimes (i (length line-labels))
                       (send self :add-line-label
                             (nth i (send current-model :line-labels))
                             (nth i (send current-model :line-xs))
                             (nth i (send current-model :line-ys)))))
        ))

    (defmeth pp :add-line-label (label x y)
      (let* ((xyc (send self :real-to-canvas x y)))
        (send self :draw-text label (+ 5 (first xyc))
              (+ 3 (second xyc)) 0 0)))
    (send lp :redraw)
    ))

(defmeth regression-model-proto :plot-bayes-residuals 
  (&key x-values (show t) location size (go-away t))
"Message args: (&optional x-values)
Opens a window with a plot of the standardized residuals and two standard
error bars for the posterior distribution of the actual deviations from the
line. See Chaloner and Brant. If X-VALUES are not supplied  the fitted values
are used. The plot can be linked to other plots with the link-views function.
Returns a plot object."
  (let* ((r (/ (send self :residuals) (send self :sigma-hat)))
         (d (* 2 (sqrt (send self :leverages))))
         (low (- r d))
         (high (+ r d))
         (x-values (if x-values x-values (send self :fit-values)))
         (p (plot-points x-values r :title "Bayes Residual Plot"
                         :point-labels (send self :case-labels)
                         :show nil
                         :go-away go-away
                         :location location
                         :size size)))
    (map 'list #'(lambda (a b c d) (send p :plotline a b c d nil))
               x-values low x-values high)
    (send p :abline 0 0)
    (send p :adjust-to-data)
    (when show (send p :show-window))
    p))


; ******* Residual Plot ************


(defproto residual-plot-proto '(model-object resid-type source) () scatterplot-proto)

(defun residual-plot 
  (model-object &key (title "Residual Plot") 
     (variable-labels (list "LS Means" "Residuals"))  
     point-labels location size (go-away t) (show t))
  (send residual-plot-proto :new model-object
        :title title :point-labels point-labels
        :variable-labels variable-labels :location location 
        :size size :go-away go-away :show show))


(defun rplot (model-object &rest args)
  (apply #'residual-plot model-object args))

(defmeth residual-plot-proto :model-object (&optional (obj-id nil set))
  (if set (setf (slot-value 'model-object) obj-id))
  (slot-value 'model-object))


(defmeth residual-plot-proto :resid-type (&optional (name1 nil set))
  (if set (setf (slot-value 'resid-type) name1))
  (slot-value 'resid-type))

(defmeth residual-plot-proto :source (&optional (name1 nil set))
  (if set (setf (slot-value 'source) name1))
  (slot-value 'source))

(defmeth residual-plot-proto :isnew 
  (model-object &key title variable-labels point-labels location 
               size go-away show)
  (call-next-method 2 :title title 
                    :location location :size size :go-away go-away :show nil)
  (send self :new-menu "ResidPlot" 
              :items '(LINK SHOWING-LABELS MOUSE RESIZE-BRUSH DASH 
                            ERASE-SELECTION FOCUS-ON-SELECTION SHOW-ALL 
                            SYMBOL COLOR SELECTION))
  (send self :model-object model-object)
  (send self :resid-type "Studentized")
  (send self :source 0)
  (send self :new-plot)
  (when show (send self :show-window))
  self)

(defmeth residual-plot-proto :new-plot (&optional sel)
    (let* ((model-obj (send self :model-object))
           (resp-var-name 
            (first (send (send model-obj :data-object) :variables)))
           (type (send self :resid-type)))
      (send self :start-buffering)
      (send self :clear)
      (when (and sel (> sel 0))
            (let* ((grouped-data (send (send model-obj :data-object) 
                                       :grouped-data (1- sel)))
                   (means (mapcar #'mean grouped-data))
                   (lsmeans nil)
                   (way (select (send (send model-obj :data-object) 
                                      :source-names) (1- sel)))
                   (residuals (send model-obj :grouped-residuals (1- sel) type)))
              (dotimes (i (length means))
                       (setf lsmeans (remove 'nil (combine lsmeans 
                                     (repeat (select means i) 
                                     (length (select grouped-data 0)))))))
              (send self :add-points lsmeans (combine residuals))
              (send self :variable-label '(0) 
                    (strcat resp-var-name " LS Means (for " way ")"))
              (send self :variable-label '(1) (strcat type " Residuals"))))
      (when (or (not sel) (= sel 0))
            (let* ((nway (send model-obj :nway-model))
                   (resids nil)
                   (y (send nway :y)))
              (cond ((equalp type "Raw") (setf resids (send nway :residuals)))
                    ((equalp type "Studentized")
                     (setf resids (send nway :studentized-residuals)))
                    ((equalp type "Externally Studentized")
                     (setf resids (send nway :externally-studentized-residuals))))
              (send self :add-points y resids)
              (send self :variable-label '(0) resp-var-name)
              (send self :variable-label '(1) (strcat type " Residuals"))))
    (send self :add-overlay (make-yaxis-overlay self))
    (send self :adjust-to-data)
    (send self :abline 0.0 0.0)
    (send self :buffer-to-screen)))
 

 

(defmeth anova-model-object-proto :grouped-residuals (source type)
  (let* ((nway (send self :nway-model))
         (residuals nil)
         (indicator (nth source (send (send self :data-object) 
                                      :indicator-matrices)))
         (nclasses (second (size indicator)))
         (members nil)
         (grouped-residuals nil))
    (cond ((equalp type "Raw")
           (setf residuals (combine (send nway :residuals))))
          ((equalp type "Studentized")
           (setf residuals (combine (send nway :studentized-residuals))))
          ((equalp type "Externally Studentized")
           (setf residuals (combine 
                            (send nway :externally-studentized-residuals))))) 
    (dotimes (i nclasses)
             (setf members (select residuals (which (= 1 (col indicator i)))))
             (setf grouped-residuals (append grouped-residuals 
                                             (list members))))
    grouped-residuals))


(defmeth anova-model-object-proto :grouped-cooks (source)
  (let* ((cooks (combine (send (send self :nway-model) :cooks-distances)))
         (indicator (nth source (send (send self :data-object) 
                                      :indicator-matrices)))
         (nclasses (second (size indicator)))
         (members nil)
         (grouped-cooks nil))
    (dotimes (i nclasses)
             (setf members (select cooks (which (= 1 (col indicator i)))))
             (setf grouped-cooks (append grouped-cooks 
                                             (list members))))
    grouped-cooks))


(defmeth residual-plot-proto :get-residuals ()  
  (let* (
         (choice nil)
         (source (send self :source))
        )
    (setf choice (choose-item-dialog "Choose one type of residuals: "
                  '("Raw Residuals"
                    "Studentized Residuals"
                    "Externally Studentized Residuals")
                   :initial 0))
    (case choice
      (0 (send self :resid-type "Raw"))
      (1 (send self :resid-type "Studentized"))
      (2 (send self :resid-type "Externally Studentized")))
    (send self :new-plot (send self :source))))

(defmeth residual-plot-proto :change-y-axis ()
  (send self :get-residuals))

(load (strcat *vista-dir-name* "anovavs2"))